package jalview.appletgui;

import jalview.datamodel.*;
import jalview.analysis.*;
import jalview.jbappletgui.GTreePanel;
import java.awt.event.*;
import java.util.*;


public class TreePanel extends GTreePanel
{
  SequenceI[] seq;
  String type;
  String pwtype;
  AlignViewport av;
  int start;
  int end;
  TreeCanvas treeCanvas;
  NJTree tree;

  public NJTree getTree()
  {
    return tree;
  }

  public TreePanel(AlignViewport av, Vector seqVector, String type, String pwtype, int s, int e)
  {
    super();

    this.type = type;
    this.pwtype = pwtype;

    start = s;
    end = e;

    String longestName = "";
    seq = new Sequence [seqVector.size()];
    for (int i=0;i < seqVector.size();i++)
    {
      seq[i] = (Sequence) seqVector.elementAt(i);
      if(seq[i].getName().length()>longestName.length())
        longestName = seq[i].getName();
    }

    tree = new NJTree(seq, type, pwtype, start, end);

    treeCanvas = new TreeCanvas(av, tree, scrollPane, longestName);

    tree.reCount(tree.getTopNode());
    tree.findHeight(tree.getTopNode());
    scrollPane.add(treeCanvas);

  }


public String getText(String format) {
  return null;
}

  protected void fitToWindow_actionPerformed(ActionEvent e)
  {
    treeCanvas.fitToWindow = fitToWindow.getState();
    repaint();
  }


  protected void fontSize_actionPerformed(ActionEvent e)
  {
 /*   if( treeCanvas==null )
     return;

   String size = fontSize.getLabel().substring( fontSize.getLabel().indexOf("-")+1);

   Object selection = JOptionPane.showInternalInputDialog(Desktop.desktop,
                               "Select font size",
                               "Font size",
                               JOptionPane.QUESTION_MESSAGE,
                               null, new String[]{"1","2","4","6","8","10","12","14","16","18","20"}
                               ,"Font Size - "+size);
   if(selection!=null)
   {
     fontSize.setText("Font Size - " + selection);

     int i = Integer.parseInt(selection.toString());
     treeCanvas.setFontSize(i);
   }
    scrollPane.setViewportView(treeCanvas);
*/
  }

  protected void distanceMenu_actionPerformed(ActionEvent e)
  {
    treeCanvas.setShowDistances(distanceMenu.getState());
  }

  protected void bootstrapMenu_actionPerformed(ActionEvent e)
  {
    treeCanvas.setShowBootstrap(bootstrapMenu.getState());
  }

}
